import { EventEmitter, Injectable, Component, HostBinding, ElementRef, TemplateRef, ContentChild, ContentChildren, Inject, forwardRef, ViewEncapsulation, ViewChild, Optional, Injector, NgZone, ChangeDetectorRef, NgModule, CUSTOM_ELEMENTS_SCHEMA } from '@angular/core';
import { DEFAULT_INPUTS_O_TEXT_INPUT, DEFAULT_INPUTS_O_INTEGER_INPUT, DEFAULT_INPUTS_O_REAL_INPUT, DEFAULT_INPUTS_O_CURRENCY_INPUT, DEFAULT_INPUTS_O_DATE_INPUT, DEFAULT_INPUTS_O_EMAIL_INPUT, DEFAULT_INPUTS_O_NIF_INPUT, DEFAULT_INPUTS_O_PASSWORD_INPUT, DEFAULT_INPUTS_O_PERCENT_INPUT, DEFAULT_INPUTS_O_TEXTAREA_INPUT, DEFAULT_INPUTS_O_COLUMN, DEFAULT_INPUTS_O_ROW, DEFAULT_INPUTS_O_COMBO, DEFAULT_INPUTS_O_LIST_PICKER, DEFAULT_INPUTS_O_CHECKBOX, DEFAULT_INPUTS_O_TABLE, InputConverter, OFormComponent, SQLTypes, OFormValue, OntimizeService, dataServiceFactory, OntimizeWebModule } from 'ontimize-web-ngx';
import { MatDialogRef, MatDialog } from '@angular/material';
import { FormGroup, FormControl, Validators } from '@angular/forms';
import { DynamicFormModule } from 'ontimize-web-ngx-dynamicform';
import { Router, ActivatedRoute } from '@angular/router';
import { CommonModule } from '@angular/common';
import { DndModule } from 'ng2-dnd';

var __extends = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var ArrayList = (function (_super) {
    __extends(ArrayList, _super);
    function ArrayList() {
        var _this = _super.call(this) || this;
        Object.setPrototypeOf(_this, Object.create(ArrayList.prototype));
        return _this;
    }
    ArrayList.prototype.size = function () {
        return this.length;
    };
    ArrayList.prototype.isEmpty = function () {
        return this.size() === 0;
    };
    ArrayList.prototype.contains = function (o) {
        return this.indexOf(o) > -1;
    };
    ArrayList.prototype.toArray = function () {
        return this;
    };
    ArrayList.prototype.containsAll = function (c) {
        var r = true, l = c.length;
        var i;
        for (i = 0; i < l && r; i++) {
            if (!this.contains(c[i])) {
                r = false;
            }
        }
        return r;
    };
    ArrayList.prototype.pushAll = function (c) {
        var _this = this;
        c.forEach(function (d) { return _this.push(d); });
        return this;
    };
    ArrayList.prototype.removeAll = function (c) {
        var _this = this;
        c.forEach(function (d) {
            if (_this.contains(d)) {
                _this.remove(_this.indexOf(d));
            }
        });
        return this;
    };
    ArrayList.prototype.clear = function () {
        this.splice(0, this.length);
    };
    ArrayList.prototype.get = function (index) {
        return this[index];
    };
    ArrayList.prototype.set = function (index, element) {
        this[index] = element;
        return this;
    };
    ArrayList.prototype.remove = function (index) {
        return this.splice(index, 1)[0];
    };
    return ArrayList;
}(Array));

var Entry = (function () {
    function Entry(t) {
        this.k = t[0], this.v = t[1];
    }
    Entry.prototype.getKey = function () {
        return this.k;
    };
    Entry.prototype.getValue = function () {
        return this.v;
    };
    return Entry;
}());

var HashMap = (function () {
    function HashMap() {
        this.keyList = new ArrayList();
        this.hashMap = new Object();
    }
    HashMap.prototype.size = function () {
        return this.entrySet().length;
    };
    HashMap.prototype.isEmpty = function () {
        return this.size() === 0;
    };
    HashMap.prototype.containsKey = function (key) {
        return this.keySet().contains(key);
    };
    HashMap.prototype.containsValue = function (value) {
        return this.values().contains(value);
    };
    HashMap.prototype.put = function (key, value) {
        if (!this.keySet().contains(key)) {
            this.keySet().push(key);
        }
        return this.hashMap[key] = value;
    };
    HashMap.prototype.remove = function (key, testValue) {
        var v;
        if (this.containsKey(key)) {
            v = this.get(key);
            if (testValue === null || testValue === undefined || testValue === v) {
                this.keyList.removeAll([key]);
                this.hashMap[key] = undefined;
                delete this.hashMap[key];
            }
        }
        return v;
    };
    HashMap.prototype.keySet = function () {
        return this.keyList;
    };
    HashMap.prototype.values = function () {
        var _this = this;
        return this.keySet().map(function (k) { return _this.get(k); });
    };
    HashMap.prototype.entrySet = function () {
        var _this = this;
        return this.keySet().map(function (k) { return new Entry([k, _this.get(k)]); });
    };
    HashMap.prototype.get = function (key) {
        return this.hashMap[key];
    };
    HashMap.prototype.getOrDefault = function (key, defaultValue) {
        return this.containsKey(key) ? this.get(key) : defaultValue;
    };
    HashMap.prototype.putAll = function (m) {
        var _this = this;
        m.forEach(function (k, v) { return _this.put(k, v); });
    };
    HashMap.prototype.removeAll = function (l) {
        var _this = this;
        l.forEach(function (e) { return _this.remove(e.getKey(), e.getValue()); });
    };
    HashMap.prototype.clear = function () {
        var _this = this;
        this.keySet().forEach(function (k) { return _this.remove(k); });
        this.keyList.clear();
    };
    HashMap.prototype.forEach = function (action) {
        this.entrySet().forEach(function (entry) {
            action(entry.getKey(), entry.getValue());
        });
    };
    HashMap.prototype.map = function (action) {
        return this.entrySet().map(function (entry) {
            return action(entry.getKey(), entry.getValue());
        });
    };
    return HashMap;
}());

var Type = (function () {
    function Type() {
    }
    Type.isNull = function (a) {
        switch (typeof a) {
            case 'undefined':
                return true;
            case 'boolean':
            case 'number':
                return false;
            default:
                return a === null || Object.keys(a).length === 0;
        }
    };
    Type.isNotNull = function (a) {
        return !Type.isNull(a);
    };
    Type.areNull = function (a) {
        var r = false;
        var i = a.length;
        while (!r && i) {
            --i;
            r = Type.isNull(a[i]);
        }
        return r;
    };
    Type.areNotNull = function (a) {
        return !Type.areNull(a);
    };
    return Type;
}());

var TreeListDefault = (function () {
    function TreeListDefault() {
        this.update = new EventEmitter();
        this.groups = new HashMap();
        this.groupsParents = new HashMap();
        this.elements = new HashMap();
        this.groupsFilter = function (a) { return a.id; };
        this.groupParentsFilter = function (a) { return a.parent; };
        this.elementsFilter = function (a) { return a.parent; };
    }
    TreeListDefault.prototype.setGroups = function (groups) {
        var _this = this;
        this.groups.clear();
        groups.forEach(function (group) {
            var key = _this.groupsFilter(group);
            _this.groups.put(key, group);
            var keyP = _this.groupParentsFilter(group);
            if (!_this.groupsParents.containsKey(keyP)) {
                _this.groupsParents.put(keyP, new Array());
            }
            _this.groupsParents.get(keyP).push(key);
        });
        this.update.emit(true);
    };
    TreeListDefault.prototype.setElements = function (elements) {
        var _this = this;
        this.elements.clear();
        elements.forEach(function (element) {
            var key = _this.elementsFilter(element);
            if (!_this.elements.containsKey(key)) {
                _this.elements.put(key, new Array());
            }
            _this.elements.get(key).push(element);
        });
        this.update.emit(true);
    };
    TreeListDefault.prototype.setGroupsFilter = function (groupsFilter) {
        this.groupsFilter = groupsFilter;
    };
    TreeListDefault.prototype.setGroupParentsFilter = function (groupParentsFilter) {
        this.groupParentsFilter = groupParentsFilter;
    };
    TreeListDefault.prototype.setElementsFilter = function (elementsFilter) {
        this.elementsFilter = elementsFilter;
    };
    TreeListDefault.prototype.build = function (key) {
        if (key === undefined || key === null) {
            key = '';
        }
        return [
            [this.groups.getOrDefault(key, '')],
            this.groupsParents.getOrDefault(key, new Array()),
            this.elements.getOrDefault(key, new Array())
        ];
    };
    return TreeListDefault;
}());

var MENU_JSON_DATA = {
    'groups': [
        {
            'icon': '',
            'id': 'LAYOUT',
            'label': 'Layout',
            'parent': ''
        },
        {
            'icon': '',
            'id': 'INPUT_FIELDS',
            'label': 'Input Fields',
            'parent': ''
        },
        {
            'icon': '',
            'id': 'SERVICE_FIELDS',
            'label': 'Service fields',
            'parent': ''
        },
        {
            'icon': '',
            'id': 'BUTTONS',
            'label': 'Buttons',
            'parent': ''
        },
        {
            'icon': '',
            'id': 'DATA',
            'label': 'Data',
            'parent': ''
        },
        {
            'icon': '',
            'id': 'MEDIA',
            'label': 'Media',
            'parent': ''
        },
        {
            'icon': '',
            'id': 'MENU',
            'label': 'Menu',
            'parent': ''
        },
        {
            'icon': '',
            'id': 'MODALS',
            'label': 'Modals',
            'parent': ''
        }
    ],
    'elements': [
        {
            'icon': null,
            'id': 'o-text-input',
            'label': 'o-text-input',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-integer-input',
            'label': 'o-integer',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-real-input',
            'label': 'o-real',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-percent-input',
            'label': 'o-percent',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-currency-input',
            'label': 'o-currency',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-nif-input',
            'label': 'o-nif',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-email-input',
            'label': 'o-email',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-password-input',
            'label': 'o-password',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-textarea-input',
            'label': 'o-textarea',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-date-input',
            'label': 'o-date',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-column',
            'label': 'Column',
            'parent': 'LAYOUT'
        },
        {
            'icon': null,
            'id': 'o-row',
            'label': 'Row',
            'parent': 'LAYOUT'
        },
        {
            'icon': null,
            'id': 'o-combo',
            'label': 'o-combo',
            'parent': 'SERVICE_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-list-picker',
            'label': 'o-list-picker',
            'parent': 'SERVICE_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-checkbox',
            'label': 'o-checkbox',
            'parent': 'INPUT_FIELDS'
        },
        {
            'icon': null,
            'id': 'o-table',
            'label': 'o-table',
            'parent': 'DATA'
        }
    ]
};

var AppMenuService = (function () {
    function AppMenuService() {
    }
    AppMenuService.prototype.getMenu = function () {
        return MENU_JSON_DATA;
    };
    AppMenuService.decorators = [
        { type: Injectable },
    ];
    return AppMenuService;
}());

var AppMenuComponent = (function () {
    function AppMenuComponent(appMenuService) {
        this.appMenuService = appMenuService;
        this.flat = false;
        this.treeList = new TreeListDefault();
        this.dragEnabled = true;
    }
    Object.defineProperty(AppMenuComponent.prototype, "uiElement", {
        get: function () {
            return this.model.uiElement;
        },
        set: function (input) {
            this.model.uiElement = input;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppMenuComponent.prototype, "closed", {
        get: function () {
            return this.model.closed;
        },
        set: function (input) {
            this.model.closed = input;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppMenuComponent.prototype, "gridType", {
        get: function () {
            switch (this.uiElement) {
                case 'sidebar':
                case 'right sidebar':
                    return 'column';
                case 'fab':
                    return 'column-reverse';
                case 'toolbar':
                    return 'row';
                case 'popup':
                case 'fullscreen':
                default:
                    return 'grid';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppMenuComponent.prototype, "gridCols", {
        get: function () {
            return this.model.gridCols;
        },
        set: function (input) {
            this.model.gridCols = input;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppMenuComponent.prototype, "treeGridCols", {
        get: function () {
            return this.model.treeGridCols;
        },
        set: function (input) {
            this.model.treeGridCols = input;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppMenuComponent.prototype, "appStyle", {
        get: function () {
            switch (this.uiElement) {
                case 'sidebar':
                case 'right sidebar':
                    return 'list';
                case 'fab':
                    return 'fab';
                case 'toolbar':
                    return 'tab';
                case 'fullscreen':
                    return 'hub';
                case 'popup':
                default:
                    return 'icon';
            }
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppMenuComponent.prototype, "onlyIcons", {
        get: function () {
            return this.model.onlyIcons;
        },
        set: function (input) {
            this.model.onlyIcons = input;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(AppMenuComponent.prototype, "model", {
        get: function () {
            return {
                items: new Array(),
                groups: new Array(),
                uiElement: 'sidebar',
                closed: false,
                onlyIcons: false,
                flat: false,
                gridCols: 3,
                treeGridCols: 3
            };
        },
        enumerable: true,
        configurable: true
    });
    AppMenuComponent.prototype.setMenu = function (menuObject) {
        this.model.groups = menuObject.groups;
        this.treeList.setGroups(menuObject.groups);
        this.model.items = menuObject.elements;
        this.treeList.setElements(menuObject.elements);
    };
    AppMenuComponent.prototype.ngAfterViewInit = function () {
        this.setMenu(this.appMenuService.getMenu());
        this.uiElement = 'sidebar';
    };
    AppMenuComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-menu',
                    inputs: [
                        'id',
                        'uiElement: ui-element',
                        'apps: docked-apps',
                        'closed',
                        'onlyIcons: only-icons',
                        'flat: ui-flat',
                        'gridCols: grid-columns',
                        'treeGridCols: tree-grid-columns',
                        'dragEnabled : drag-enabled'
                    ],
                    template: "\n    <app-menu-frame fxFlexFill [ui-element]=\"uiElement\" [ui-closed]=\"closed\" [ui-flat]=\"flat\">\n      <tree-grid class=\"contained\"\n        [tree-grid]=\"treeList\"\n        [grid-type]=\"gridType\"\n        [grid-columns]=\"gridCols\"\n        [tree-grid-columns]=\"treeGridCols\">\n\n        <ng-template let-app>\n          <app-menu-title\n            [app-label]=\"app.label\"\n            [app-style]=\"appStyle\"\n            [only-icons]=\"onlyIcons\"\n            [title-closed]=\"app.closed\">\n          </app-menu-title>\n        </ng-template>\n\n        <ng-template let-app>\n          <app-menu-item\n            [app-icon]=\"app.icon\"\n            [app-label]=\"app.label\"\n            [app-id]=\"app.id\"\n            [app-style]=\"appStyle\"\n            [only-icons]=\"onlyIcons\"\n            [drag-enabled]=\"dragEnabled\"\n            app-indent=\"6px\">\n          </app-menu-item>\n        </ng-template>\n      </tree-grid>\n      <ng-content class=\"framed\"></ng-content>\n    </app-menu-frame>\n  ",
                    styles: ["\n    ::-webkit-scrollbar{width:5px;height:4px}::-webkit-scrollbar-button{width:0px;height:0px}::-webkit-scrollbar-thumb{background:rgba(255,223,119,0.2)}::-webkit-scrollbar-track{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb:active{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb,::-webkit-scrollbar-track{border:none}::-webkit-scrollbar-track:hover,::-webkit-scrollbar-track:active,::-webkit-scrollbar-corner{background:transparent}o-dynamic-form-builder .dynamicform-container{height:100%}o-dynamic-form-builder .dynamicform-container .dropzone-container{height:95%;overflow:auto}app-menu-frame .menu-frame-container,mat-toolbar{background-color:#da4644;color:#eee}:host app-menu-frame .menu-frame-container{background-color:#da4644;box-shadow:0em 0em 0em 0em black, 0em 0em 0em 0em black inset}\n  "]
                },] },
    ];
    AppMenuComponent.ctorParameters = function () { return [
        { type: AppMenuService, },
    ]; };
    return AppMenuComponent;
}());

var AppMenuTitle = (function () {
    function AppMenuTitle() {
        this.label = '';
        this.closed = false;
    }
    return AppMenuTitle;
}());

var __extends$1 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var AppMenuTitleComponent = (function (_super) {
    __extends$1(AppMenuTitleComponent, _super);
    function AppMenuTitleComponent() {
        return _super.call(this) || this;
    }
    AppMenuTitleComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-menu-title',
                    inputs: [
                        'label: app-label',
                        'style: app-style',
                        'onlyIcons: only-icons',
                        'closed: title-closed'
                    ],
                    template: "\n    <div [ngClass]=\"['title', style]\" title=\"{{ label }}\">\n      <div class=\"title-label\" fxLayout=\"center\">\n        <span class=\"title-label-text\" fxFlex>{{ label }}</span>\n      </div>\n      <button mat-button>\n        <mat-icon class=\"material-icons title-icon\" [class.closed]=\"closed\" border=\"0\">expand_more</mat-icon>\n      </button>\n    </div>\n  ",
                    styles: ["\n    ::-webkit-scrollbar{width:5px;height:4px}::-webkit-scrollbar-button{width:0px;height:0px}::-webkit-scrollbar-thumb{background:rgba(255,223,119,0.2)}::-webkit-scrollbar-track{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb:active{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb,::-webkit-scrollbar-track{border:none}::-webkit-scrollbar-track:hover,::-webkit-scrollbar-track:active,::-webkit-scrollbar-corner{background:transparent}o-dynamic-form-builder .dynamicform-container{height:100%}o-dynamic-form-builder .dynamicform-container .dropzone-container{height:95%;overflow:auto}:host{user-select:none}:host .title{display:flex;flex-direction:row;height:48px;line-height:48px}:host .title-label{flex:1 1 auto;padding-left:8px}:host button{width:48px;min-width:48px;height:48px;line-height:48px;padding:0}:host .title-icon{flex:0 0 auto;width:48px;height:48px;line-height:48px;transition:350ms;transition-timing-function:ease-in-out;transform:rotate(180deg)}:host .title-icon.closed{transform:rotate(0deg)}:host.nolabels .title{text-align:center}:host.nolabels .title .title-label{display:none !important}:host.nolabels .title .title-icon{padding:0 !important}\n  "]
                },] },
    ];
    AppMenuTitleComponent.ctorParameters = function () { return []; };
    AppMenuTitleComponent.propDecorators = {
        "onlyIcons": [{ type: HostBinding, args: ['class.nolabels',] },],
    };
    return AppMenuTitleComponent;
}(AppMenuTitle));

var OComponentData = (function () {
    function OComponentData() {
        this.configuredInputs = {};
        if (this.isContainer()) {
            this.children = new ArrayList();
        }
    }
    OComponentData.prototype.getDirective = function () {
        return '';
    };
    OComponentData.prototype.getInputsProperties = function () {
        return [];
    };
    OComponentData.prototype.getInputs = function () {
        var rawProperties = this.getInputsProperties();
        var parsedProperties = [];
        for (var i = 0; i < rawProperties.length; i++) {
            var splitted = rawProperties[i].split(':');
            parsedProperties.push(splitted[splitted.length - 1].trim());
        }
        return parsedProperties;
    };
    OComponentData.prototype.getTemplateInputsData = function () {
        return {
            'attr': {
                'type': 'string',
                'label': 'attr',
                'tooltip': '',
                'default': null,
                'required': true
            }
        };
    };
    OComponentData.prototype.isContainer = function () {
        return false;
    };
    OComponentData.prototype.setConfiguredInputs = function (data) {
        this.configuredInputs = Object.assign(this.configuredInputs, data);
    };
    OComponentData.prototype.getComponentAttr = function () {
        return this.configuredInputs ? this.configuredInputs.attr : undefined;
    };
    OComponentData.prototype.getConfiguredInputs = function () {
        return this.configuredInputs;
    };
    OComponentData.prototype.getConfiguredInputValue = function (inputName) {
        return this.configuredInputs ? this.configuredInputs[inputName] : undefined;
    };
    OComponentData.prototype.addChild = function (child) {
        this.children.push(child);
    };
    OComponentData.prototype.getChildren = function () {
        return this.children;
    };
    return OComponentData;
}());

var __extends$2 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OComponenetDataInput = (function (_super) {
    __extends$2(OComponenetDataInput, _super);
    function OComponenetDataInput() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OComponenetDataInput.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['label'] = {
            'type': 'string',
            'label': 'label',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['tooltip'] = {
            'type': 'string',
            'label': 'tooltip',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['tooltip-position'] = {
            'type': 'combo',
            'label': 'tooltip-position',
            'tooltip': '',
            'default': 'below',
            'required': false,
            'values': [
                'before',
                'after',
                'above',
                'below',
                'left',
                'right'
            ]
        };
        templateInputsData['tooltip-show-delay'] = {
            'type': 'number',
            'label': 'tooltip-show-delay',
            'tooltip': '',
            'default': 500,
            'required': false
        };
        templateInputsData['data'] = {
            'type': 'string',
            'label': 'data',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['automatic-binding'] = {
            'type': 'boolean',
            'label': 'automatic-binding',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['automatic-registering'] = {
            'type': 'boolean',
            'label': 'automatic-registering',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['enabled'] = {
            'type': 'boolean',
            'label': 'enabled',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['required'] = {
            'type': 'boolean',
            'label': 'required',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['sql-type'] = {
            'type': 'combo',
            'label': 'sql-type',
            'tooltip': '',
            'default': 'OTHER',
            'required': true,
            'values': [
                'BIT',
                'TINYINT',
                'SMALLINT',
                'INTEGER',
                'BIGINT',
                'FLOAT',
                'REAL',
                'DOUBLE',
                'NUMERIC',
                'DECIMAL',
                'CHAR',
                'VARCHAR',
                'LONGVARCHAR',
                'DATE',
                'TIME',
                'TIMESTAMP',
                'BINARY',
                'VARBINARY',
                'LONGVARBINARY',
                'NULL',
                'OTHER',
                'JAVA_OBJECT',
                'DISTINCT',
                'STRUCT',
                'ARRAY',
                'BLOB',
                'CLOB',
                'REF',
                'DATALINK',
                'BOOLEAN',
                'ROWID',
                'NCHAR',
                'NVARCHAR',
                'LONGNVARCHAR',
                'NCLOB',
                'SQLXML'
            ]
        };
        return templateInputsData;
    };
    return OComponenetDataInput;
}(OComponentData));

var __extends$3 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OTextInputData = (function (_super) {
    __extends$3(OTextInputData, _super);
    function OTextInputData() {
        return _super.call(this) || this;
    }
    OTextInputData.prototype.getDirective = function () {
        return 'o-text-input';
    };
    OTextInputData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_TEXT_INPUT;
    };
    OTextInputData.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['min-length'] = {
            'type': 'number',
            'label': 'min-length',
            'tooltip': '',
            'default': -1,
            'required': false
        };
        templateInputsData['max-length'] = {
            'type': 'number',
            'label': 'max-length',
            'tooltip': '',
            'default': -1,
            'required': false
        };
        return templateInputsData;
    };
    return OTextInputData;
}(OComponenetDataInput));

var __extends$4 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OIntegerInputData = (function (_super) {
    __extends$4(OIntegerInputData, _super);
    function OIntegerInputData() {
        return _super.call(this) || this;
    }
    OIntegerInputData.prototype.getDirective = function () {
        return 'o-integer-input';
    };
    OIntegerInputData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_INTEGER_INPUT;
    };
    OIntegerInputData.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['min'] = {
            'type': 'number',
            'label': 'min',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['max'] = {
            'type': 'number',
            'label': 'max',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['step'] = {
            'type': 'number',
            'label': 'step',
            'tooltip': '',
            'default': 1,
            'required': false
        };
        templateInputsData['grouping'] = {
            'type': 'boolean',
            'label': 'grouping',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['thousand-separator'] = {
            'type': 'string',
            'label': 'thousand-separator',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['locale'] = {
            'type': 'string',
            'label': 'locale',
            'tooltip': '',
            'default': null,
            'required': false
        };
        return templateInputsData;
    };
    return OIntegerInputData;
}(OTextInputData));

var __extends$5 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var ORealInputData = (function (_super) {
    __extends$5(ORealInputData, _super);
    function ORealInputData() {
        return _super.call(this) || this;
    }
    ORealInputData.prototype.getDirective = function () {
        return 'o-real-input';
    };
    ORealInputData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_REAL_INPUT;
    };
    ORealInputData.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['min-decimal-digits'] = {
            'type': 'number',
            'label': 'min-length',
            'tooltip': '',
            'default': 2,
            'required': true
        };
        templateInputsData['max-decimal-digits'] = {
            'type': 'number',
            'label': 'max-length',
            'tooltip': '',
            'default': 2,
            'required': true
        };
        templateInputsData['decimal-separator'] = {
            'type': 'string',
            'label': 'decimal-separator',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['decimal-digits'] = {
            'type': 'number',
            'label': 'decimal-digits',
            'tooltip': '',
            'default': 2,
            'required': false
        };
        return templateInputsData;
    };
    return ORealInputData;
}(OIntegerInputData));

var __extends$6 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OCurrencyInputData = (function (_super) {
    __extends$6(OCurrencyInputData, _super);
    function OCurrencyInputData() {
        return _super.call(this) || this;
    }
    OCurrencyInputData.prototype.getDirective = function () {
        return 'o-currency-input';
    };
    OCurrencyInputData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_CURRENCY_INPUT;
    };
    OCurrencyInputData.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['currency-symbol'] = {
            'type': 'combo',
            'label': 'currency-symbol',
            'tooltip': '',
            'default': 'EUR',
            'required': false,
            'values': [
                'USD',
                'EUR',
                'CRC',
                'GBP',
                'ILS',
                'INR',
                'JPY',
                'KRW',
                'NGN',
                'PHP',
                'PLN',
                'PYG',
                'THB',
                'UAH',
                'VND'
            ]
        };
        templateInputsData['currency-symbol-position'] = {
            'type': 'combo',
            'label': 'currency-symbol-position',
            'tooltip': '',
            'default': 'right',
            'required': false,
            'values': [
                'left',
                'right'
            ]
        };
        return templateInputsData;
    };
    return OCurrencyInputData;
}(ORealInputData));

var __extends$7 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var ODateInputData = (function (_super) {
    __extends$7(ODateInputData, _super);
    function ODateInputData() {
        return _super.call(this) || this;
    }
    ODateInputData.prototype.getDirective = function () {
        return 'o-date-input';
    };
    ODateInputData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_DATE_INPUT;
    };
    ODateInputData.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['format'] = {
            'type': 'string',
            'label': 'format',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['locale'] = {
            'type': 'string',
            'label': 'locale',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['touch-ui'] = {
            'type': 'boolean',
            'label': 'touch-ui',
            'tooltip': '',
            'default': false,
            'required': false
        };
        return templateInputsData;
    };
    return ODateInputData;
}(OTextInputData));

var __extends$8 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OEmailInputData = (function (_super) {
    __extends$8(OEmailInputData, _super);
    function OEmailInputData() {
        return _super.call(this) || this;
    }
    OEmailInputData.prototype.getDirective = function () {
        return 'o-email-input';
    };
    OEmailInputData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_EMAIL_INPUT;
    };
    return OEmailInputData;
}(OTextInputData));

var __extends$9 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var ONifInputData = (function (_super) {
    __extends$9(ONifInputData, _super);
    function ONifInputData() {
        return _super.call(this) || this;
    }
    ONifInputData.prototype.getDirective = function () {
        return 'o-nif-input';
    };
    ONifInputData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_NIF_INPUT;
    };
    return ONifInputData;
}(OTextInputData));

var __extends$10 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OPasswordInputData = (function (_super) {
    __extends$10(OPasswordInputData, _super);
    function OPasswordInputData() {
        return _super.call(this) || this;
    }
    OPasswordInputData.prototype.getDirective = function () {
        return 'o-password-input';
    };
    OPasswordInputData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_PASSWORD_INPUT;
    };
    return OPasswordInputData;
}(OTextInputData));

var __extends$11 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OPercentInputData = (function (_super) {
    __extends$11(OPercentInputData, _super);
    function OPercentInputData() {
        return _super.call(this) || this;
    }
    OPercentInputData.prototype.getDirective = function () {
        return 'o-percent-input';
    };
    OPercentInputData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_PERCENT_INPUT;
    };
    return OPercentInputData;
}(ORealInputData));

var __extends$12 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OTextareaInputData = (function (_super) {
    __extends$12(OTextareaInputData, _super);
    function OTextareaInputData() {
        return _super.call(this) || this;
    }
    OTextareaInputData.prototype.getDirective = function () {
        return 'o-textarea-input';
    };
    OTextareaInputData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_TEXTAREA_INPUT;
    };
    OTextareaInputData.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['columns'] = {
            'type': 'number',
            'label': 'columns',
            'tooltip': '',
            'default': 5,
            'required': false
        };
        templateInputsData['rows'] = {
            'type': 'number',
            'label': 'rows',
            'tooltip': '',
            'default': null,
            'required': false
        };
        return templateInputsData;
    };
    return OTextareaInputData;
}(OTextInputData));

var __extends$13 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OComponentDataLayout = (function (_super) {
    __extends$13(OComponentDataLayout, _super);
    function OComponentDataLayout() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OComponentDataLayout.prototype.isContainer = function () {
        return true;
    };
    OComponentDataLayout.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['title-label'] = {
            'type': 'string',
            'label': 'title-label',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['layout-align'] = {
            'type': 'combo',
            'label': 'layout-align',
            'tooltip': '',
            'default': 'start start',
            'required': false,
            'values': [
                'start start',
                'start center',
                'start end',
                'start stretch',
                'center start',
                'center center',
                'center end',
                'center stretch',
                'end start',
                'end center',
                'end end',
                'end stretch',
                'space-around start',
                'space-around center',
                'space-around end',
                'space-around stretch',
                'space-between start',
                'space-between center',
                'space-between end',
                'space-between stretch'
            ]
        };
        templateInputsData['layout-fill'] = {
            'type': 'boolean',
            'label': 'layout-fill',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['elevation'] = {
            'type': 'number',
            'label': 'elevation',
            'tooltip': '',
            'default': 0,
            'required': false
        };
        return templateInputsData;
    };
    return OComponentDataLayout;
}(OComponentData));

var __extends$14 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OColumnData = (function (_super) {
    __extends$14(OColumnData, _super);
    function OColumnData() {
        return _super.call(this) || this;
    }
    OColumnData.prototype.getDirective = function () {
        return 'o-column';
    };
    OColumnData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_COLUMN;
    };
    return OColumnData;
}(OComponentDataLayout));

var __extends$15 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var ORowData = (function (_super) {
    __extends$15(ORowData, _super);
    function ORowData() {
        return _super.call(this) || this;
    }
    ORowData.prototype.getDirective = function () {
        return 'o-row';
    };
    ORowData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_ROW;
    };
    return ORowData;
}(OComponentDataLayout));

var __extends$16 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OComponentFormDataService = (function (_super) {
    __extends$16(OComponentFormDataService, _super);
    function OComponentFormDataService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OComponentFormDataService.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['static-data'] = {
            'type': 'json',
            'label': 'static-data',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['entity'] = {
            'type': 'string',
            'label': 'entity',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['service'] = {
            'type': 'string',
            'label': 'service',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['columns'] = {
            'type': 'string',
            'label': 'columns',
            'tooltip': '',
            'default': null,
            'required': true
        };
        templateInputsData['value-column'] = {
            'type': 'string',
            'label': 'value-column',
            'tooltip': '',
            'default': null,
            'required': true
        };
        templateInputsData['value-column-type'] = {
            'type': 'string',
            'label': 'value-column-type',
            'tooltip': '',
            'default': 'int',
            'required': true
        };
        templateInputsData['parent-keys'] = {
            'type': 'string',
            'label': 'parent-keys',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['visible-columns'] = {
            'type': 'string',
            'label': 'visible-columns',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['description-columns'] = {
            'type': 'string',
            'label': 'description-columns',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['separator'] = {
            'type': 'string',
            'label': 'separator',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['query-on-init'] = {
            'type': 'boolean',
            'label': 'query-on-init',
            'tooltip': '',
            'default': true,
            'required': true
        };
        templateInputsData['query-on-bind'] = {
            'type': 'boolean',
            'label': 'query-on-bind',
            'tooltip': '',
            'default': false,
            'required': true
        };
        templateInputsData['service-type'] = {
            'type': 'string',
            'label': 'service-type',
            'tooltip': '',
            'default': null,
            'required': false
        };
        return templateInputsData;
    };
    return OComponentFormDataService;
}(OComponenetDataInput));

var __extends$17 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OComboData = (function (_super) {
    __extends$17(OComboData, _super);
    function OComboData() {
        return _super.call(this) || this;
    }
    OComboData.prototype.getDirective = function () {
        return 'o-combo';
    };
    OComboData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_COMBO;
    };
    OComboData.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['translate'] = {
            'type': 'boolean',
            'label': 'translate',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['null-selection'] = {
            'type': 'boolean',
            'label': 'null-selection',
            'tooltip': '',
            'default': true,
            'required': true
        };
        return templateInputsData;
    };
    return OComboData;
}(OComponentFormDataService));

var __extends$18 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OListPickerData = (function (_super) {
    __extends$18(OListPickerData, _super);
    function OListPickerData() {
        return _super.call(this) || this;
    }
    OListPickerData.prototype.getDirective = function () {
        return 'o-list-picker';
    };
    OListPickerData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_LIST_PICKER;
    };
    OListPickerData.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['filter'] = {
            'type': 'boolean',
            'label': 'filter',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['dialog-width'] = {
            'type': 'string',
            'label': 'dialog-width',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['dialog-height'] = {
            'type': 'string',
            'label': 'dialog-height',
            'tooltip': '',
            'default': null,
            'required': false
        };
        return templateInputsData;
    };
    return OListPickerData;
}(OComponentFormDataService));

var __extends$19 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OCheckboxData = (function (_super) {
    __extends$19(OCheckboxData, _super);
    function OCheckboxData() {
        return _super.call(this) || this;
    }
    OCheckboxData.prototype.getDirective = function () {
        return 'o-checkbox';
    };
    OCheckboxData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_CHECKBOX;
    };
    OCheckboxData.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['data'] = {
            'type': 'boolean',
            'label': 'data',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['sql-type'] = {
            'type': 'combo',
            'label': 'sql-type',
            'tooltip': '',
            'default': 'BOOLEAN',
            'required': true,
            'values': [
                'BOOLEAN'
            ]
        };
        return templateInputsData;
    };
    return OCheckboxData;
}(OComponenetDataInput));

var __extends$20 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OComponentDataService = (function (_super) {
    __extends$20(OComponentDataService, _super);
    function OComponentDataService() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    OComponentDataService.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['title'] = {
            'type': 'string',
            'label': 'title',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['css-class'] = {
            'type': 'string',
            'label': 'css-class',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['visible'] = {
            'type': 'boolean',
            'label': 'visible',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['enabled'] = {
            'type': 'boolean',
            'label': 'enabled',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['controls'] = {
            'type': 'boolean',
            'label': 'controls',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['service'] = {
            'type': 'string',
            'label': 'service',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['entity'] = {
            'type': 'string',
            'label': 'entity',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['query-method'] = {
            'type': 'string',
            'label': 'query-method',
            'tooltip': '',
            'default': 'query',
            'required': false
        };
        templateInputsData['paginated-query-method'] = {
            'type': 'string',
            'label': 'paginated-query-method',
            'tooltip': '',
            'default': 'advancedQuery',
            'required': false
        };
        templateInputsData['delete-method'] = {
            'type': 'string',
            'label': 'delete-method',
            'tooltip': '',
            'default': 'delete',
            'required': false
        };
        templateInputsData['query-on-init'] = {
            'type': 'boolean',
            'label': 'query-on-init',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['query-on-bind'] = {
            'type': 'boolean',
            'label': 'query-on-bind',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['pageable'] = {
            'type': 'boolean',
            'label': 'pageable',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['columns'] = {
            'type': 'string',
            'label': 'columns',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['keys'] = {
            'type': 'string',
            'label': 'keys',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['parent-keys'] = {
            'type': 'string',
            'label': 'parent-keys',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['static-data'] = {
            'type': 'json',
            'label': 'static-data',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['detail-mode'] = {
            'type': 'combo',
            'label': 'detail-mode',
            'tooltip': '',
            'default': 'none',
            'required': false,
            'values': [
                'none',
                'click',
                'doubleclick'
            ]
        };
        templateInputsData['detail-form-route'] = {
            'type': 'string',
            'label': 'detail-form-route',
            'tooltip': '',
            'default': 'detail',
            'required': false
        };
        templateInputsData['recursive-detail'] = {
            'type': 'boolean',
            'label': 'recursive-detail',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['detail-button-in-row'] = {
            'type': 'boolean',
            'label': 'detail-button-in-row',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['detail-button-in-row-icon'] = {
            'type': 'string',
            'label': 'detail-button-in-row-icon',
            'tooltip': '',
            'default': 'mode_edit',
            'required': false
        };
        templateInputsData['edit-form-route'] = {
            'type': 'string',
            'label': 'edit-form-route',
            'tooltip': '',
            'default': 'edit',
            'required': false
        };
        templateInputsData['recursive-edit'] = {
            'type': 'boolean',
            'label': 'recursive-edit',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['edit-button-in-row'] = {
            'type': 'boolean',
            'label': 'edit-button-in-row',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['edit-button-in-row-icon'] = {
            'type': 'string',
            'label': 'edit-button-in-row-icon',
            'tooltip': '',
            'default': 'search',
            'required': false
        };
        templateInputsData['query-rows'] = {
            'type': 'number',
            'label': 'query-rows',
            'tooltip': '',
            'default': 10,
            'required': false
        };
        templateInputsData['insert-button'] = {
            'type': 'boolean',
            'label': 'insert-button',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['row-height'] = {
            'type': 'combo',
            'label': 'row-height',
            'tooltip': '',
            'default': null,
            'required': false,
            'values': [
                'small',
                'medium',
                'large'
            ]
        };
        templateInputsData['service-type'] = {
            'type': 'string',
            'label': 'service-type',
            'tooltip': '',
            'default': null,
            'required': false
        };
        return templateInputsData;
    };
    return OComponentDataService;
}(OComponentData));

var __extends$21 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var OTableData = (function (_super) {
    __extends$21(OTableData, _super);
    function OTableData() {
        return _super.call(this) || this;
    }
    OTableData.prototype.getDirective = function () {
        return 'o-table';
    };
    OTableData.prototype.getInputsProperties = function () {
        return DEFAULT_INPUTS_O_TABLE;
    };
    OTableData.prototype.getTemplateInputsData = function () {
        var templateInputsData = _super.prototype.getTemplateInputsData.call(this);
        templateInputsData['insert-method'] = {
            'type': 'string',
            'label': 'insert-method',
            'tooltip': '',
            'default': 'insert',
            'required': false
        };
        templateInputsData['update-method'] = {
            'type': 'string',
            'label': 'update-method',
            'tooltip': '',
            'default': 'update',
            'required': false
        };
        templateInputsData['visible-columns'] = {
            'type': 'string',
            'label': 'visible-columns',
            'tooltip': '',
            'default': '',
            'required': false
        };
        templateInputsData[''] = {
            'type': 'number',
            'label': '',
            'tooltip': '',
            'default': -1,
            'required': false
        };
        templateInputsData['editable-columns'] = {
            'type': 'string',
            'label': 'editable-columns',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['sort-columns'] = {
            'type': 'string',
            'label': 'sort-columns',
            'tooltip': '',
            'default': null,
            'required': false
        };
        templateInputsData['quick-filter'] = {
            'type': 'boolean',
            'label': 'quick-filter',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['delete-button'] = {
            'type': 'boolean',
            'label': 'delete-button',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['refresh-button'] = {
            'type': 'boolean',
            'label': 'refresh-button',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['columns-visibility-button'] = {
            'type': 'boolean',
            'label': 'columns-visibility-button',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['export-button'] = {
            'type': 'boolean',
            'label': 'export-button',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['show-table-buttons-text'] = {
            'type': 'boolean',
            'label': 'show-table-buttons-text',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['select-all-checkbox'] = {
            'type': 'boolean',
            'label': 'select-all-checkbox',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['pagination-controls'] = {
            'type': 'boolean',
            'label': 'pagination-controls',
            'tooltip': '',
            'default': true,
            'required': false
        };
        templateInputsData['filter-case-sensitive'] = {
            'type': 'boolean',
            'label': 'filter-case-sensitive',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['fixed-header'] = {
            'type': 'boolean',
            'label': 'fixed-header',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['show-title'] = {
            'type': 'boolean',
            'label': 'show-title',
            'tooltip': '',
            'default': false,
            'required': false
        };
        templateInputsData['edition-mode'] = {
            'type': 'combo',
            'label': 'edition-mode',
            'tooltip': '',
            'default': 'none',
            'required': false,
            'values': [
                'none',
                'inline',
                'click',
                'dblclick'
            ]
        };
        templateInputsData['selection-mode'] = {
            'type': 'combo',
            'label': 'selection-mode',
            'tooltip': '',
            'default': -1,
            'required': false,
            'values': [
                'none',
                'simple',
                'multiple'
            ]
        };
        return templateInputsData;
    };
    return OTableData;
}(OComponentDataService));

var ComponentsDataService = (function () {
    function ComponentsDataService() {
        this.constructors = {
            'o-currency-input': OCurrencyInputData,
            'o-date-input': ODateInputData,
            'o-email-input': OEmailInputData,
            'o-integer-input': OIntegerInputData,
            'o-nif-input': ONifInputData,
            'o-password-input': OPasswordInputData,
            'o-percent-input': OPercentInputData,
            'o-real-input': ORealInputData,
            'o-text-input': OTextInputData,
            'o-textarea-input': OTextareaInputData,
            'o-column': OColumnData,
            'o-row': ORowData,
            'o-combo': OComboData,
            'o-list-picker': OListPickerData,
            'o-checkbox': OCheckboxData,
            'o-table': OTableData
        };
    }
    ComponentsDataService.prototype.getOntimizeComponentData = function (componentName) {
        if (this.constructors.hasOwnProperty(componentName)) {
            return new this.constructors[componentName]();
        }
        return new OComponentData();
    };
    ComponentsDataService.decorators = [
        { type: Injectable },
    ];
    return ComponentsDataService;
}());

var DEFAULT_INPUTS_APP_MENU_ITEM = [
    'label: app-label',
    'icon: app-icon',
    'style: app-style',
    'indent: app-indent',
    'onlyIcons: only-icons',
    'id : app-id',
    'componentDragEnabled : drag-enabled'
];
var DEFAULT_OUTPUTS_APP_MENU_ITEM = [];
var AppMenuItemComponent = (function () {
    function AppMenuItemComponent(componentsDataService) {
        this.componentsDataService = componentsDataService;
        this.label = '';
        this.componentDragEnabled = true;
    }
    AppMenuItemComponent.prototype.ngOnInit = function () {
        if (!this.icon) {
            this.noIcon = true;
        }
    };
    AppMenuItemComponent.prototype.getDraggableData = function () {
        return this.componentsDataService.getOntimizeComponentData(this.id);
    };
    AppMenuItemComponent.DEFAULT_INPUTS_APP_MENU_ITEM = DEFAULT_INPUTS_APP_MENU_ITEM;
    AppMenuItemComponent.DEFAULT_OUTPUTS_APP_MENU_ITEM = DEFAULT_OUTPUTS_APP_MENU_ITEM;
    AppMenuItemComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-menu-item',
                    inputs: DEFAULT_INPUTS_APP_MENU_ITEM,
                    outputs: DEFAULT_OUTPUTS_APP_MENU_ITEM,
                    template: "\n    <button dnd-draggable [dragEnabled]=\"componentDragEnabled\" [dragData]=\"getDraggableData()\" [class.only-label]=\"icon\" class=\"item {{ style }}\"\n      title=\"{{ label }}\">\n      <mat-icon *ngIf=\"icon\" class=\"material-icons item-icon\" border=\"0\" [style.paddingLeft]=\"indent\">\n        {{icon}}\n      </mat-icon>\n      <div class=\"item-label\" fxLayout=\"center\">\n        <span class=\"item-label-text\">{{ label }}</span>\n      </div>\n    </button>\n  ",
                    styles: ["\n    ::-webkit-scrollbar{width:5px;height:4px}::-webkit-scrollbar-button{width:0px;height:0px}::-webkit-scrollbar-thumb{background:rgba(255,223,119,0.2)}::-webkit-scrollbar-track{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb:active{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb,::-webkit-scrollbar-track{border:none}::-webkit-scrollbar-track:hover,::-webkit-scrollbar-track:active,::-webkit-scrollbar-corner{background:transparent}o-dynamic-form-builder .dynamicform-container{height:100%}o-dynamic-form-builder .dynamicform-container .dropzone-container{height:95%;overflow:auto}:host{display:block;position:relative;width:100%;height:100%;cursor:pointer;user-select:none}button{display:block;border:0;background:inherit;color:inherit}button.dnd-drag-start{border:2px dashed #000}.item{width:100%;padding:0 8px;white-space:nowrap;overflow:hidden}.item .item-icon{width:auto;height:auto;vertical-align:middle;white-space:normal}.item .item-label{vertical-align:middle;white-space:normal}.item .item-label .item-label-text{width:100%}.item:hover{background-color:rgba(255,255,255,0.3)}.item.icon .item-icon{padding:0 !important;font-size:56px}.item.icon .item-label .item-label-text{font-size:12px}.item.list{outline:none;text-align:left;height:48px;min-width:48px}.item.list .item-icon{display:inline-block;font-size:24px}.item.list .item-label{display:inline-block;margin:0 8px}.item.fab{text-align:left;height:40px;width:40px;font-size:0.8rem;background:#da4644;border-radius:48px;margin:4px auto;box-shadow:0px 0.16em 8px -0.16em black, 0em 0em 0em 0em black inset !important}.item.fab .item-icon{display:inline-block;font-size:24px}.item.fab .item-label{display:none}.item.tab{height:48px;min-width:48px}.item.tab .item-icon{padding:0 !important;display:inline-block;font-size:24px}.item.tab .item-label{display:inline-block;margin:0 8px}.item.hub{max-width:256px;margin:0 auto}.item.hub .item-icon{padding:0 !important;font-size:128px}.item.hub .item-label .item-label-text{font-size:16px;padding-bottom:14px}:host.nolabels .item{text-align:center}:host.nolabels .item .item-icon{padding:0 !important}:host.nolabels .item .item-label{display:none !important}:host.nolabels.only-label .item{height:initial}\n  "]
                },] },
    ];
    AppMenuItemComponent.ctorParameters = function () { return [
        { type: ComponentsDataService, },
    ]; };
    AppMenuItemComponent.propDecorators = {
        "onlyIcons": [{ type: HostBinding, args: ['class.nolabels',] },],
        "noIcon": [{ type: HostBinding, args: ['class.only-label',] },],
    };
    return AppMenuItemComponent;
}());

var AppMenuFrameComponent = (function () {
    function AppMenuFrameComponent(myElement) {
        this.myElement = myElement;
        this.element = 'popup';
        this.closed = false;
        this.x = '0';
        this.y = '0';
        this.flat = false;
    }
    AppMenuFrameComponent.prototype.ngOnAfterViewInit = function () {
        this.fixPosition();
    };
    AppMenuFrameComponent.prototype.ngOnChanges = function () {
        switch (this.element) {
            case 'popup':
                this.isDraggable = true;
                this.fixPosition();
                break;
            default:
                this.isDraggable = false;
                break;
        }
    };
    Object.defineProperty(AppMenuFrameComponent.prototype, "isDraggable", {
        get: function () {
            return this.draggable;
        },
        set: function (val) {
            this.draggable = val;
        },
        enumerable: true,
        configurable: true
    });
    AppMenuFrameComponent.prototype.setPosition = function (x, y) {
        this.x = x.toString();
        this.y = y.toString();
        this.fixPosition();
    };
    AppMenuFrameComponent.prototype.fixPosition = function () {
        var x = parseInt(this.x), w = window.innerWidth, y = parseInt(this.y), h = window.innerHeight;
        if (x >= w * 0.6) {
            this.x = (w * 0.6).toString();
        }
        if (y >= h * 0.2) {
            this.y = (h * 0.2).toString();
        }
        this.applyPosition();
    };
    AppMenuFrameComponent.prototype.applyPosition = function () {
        this.left = this.x + 'px';
        this.top = this.y + 'px';
    };
    AppMenuFrameComponent.decorators = [
        { type: Component, args: [{
                    selector: 'app-menu-frame',
                    inputs: [
                        'element: ui-element',
                        'closed: ui-closed',
                        'flat: ui-flat',
                        'x: ui-x',
                        'y: ui-y'
                    ],
                    template: "\n    <div [class]=\"element\" fxFlexFill color=\"primary\">\n        <div class=\"menu-frame-container\" [class.closed]=\"closed\" [class.flat]=\"flat\" [draggable]=\"isDraggable\" [class.draggable]=\"isDraggable\">\n            <div class=\"content\" fxFlexFill>\n                <ng-content select=\".contained\"></ng-content>\n            </div>\n        </div>\n        <div class=\"framer\">\n            <div class=\"content\" fxFlexFill>\n                <ng-content select=\".framed\"></ng-content>\n            </div>\n        </div>\n    </div>\n  ",
                    styles: ["\n    ::-webkit-scrollbar{width:5px;height:4px}::-webkit-scrollbar-button{width:0px;height:0px}::-webkit-scrollbar-thumb{background:rgba(255,223,119,0.2)}::-webkit-scrollbar-track{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb:active{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb,::-webkit-scrollbar-track{border:none}::-webkit-scrollbar-track:hover,::-webkit-scrollbar-track:active,::-webkit-scrollbar-corner{background:transparent}o-dynamic-form-builder .dynamicform-container{height:100%}o-dynamic-form-builder .dynamicform-container .dropzone-container{height:95%;overflow:auto}:host{display:block}:host>div>.menu-frame-container{position:relative;flex:0 0 auto;z-index:2}:host>div>.menu-frame-container.flat{box-shadow:0em 0em 0em 0em black, 0em 0em 0em 0em black inset !important}:host>div>.framer{position:relative;flex:1 1 auto;z-index:1}:host>div>.framer>.content{position:absolute}:host>div>.menu-frame-container{max-width:100%;max-height:200%}:host>div>.menu-frame-container.closed{min-width:0;min-height:0}:host>div>.menu-frame-container,:host>div>.framer{overflow:auto;transition:350ms;transition-timing-function:ease-in-out;box-shadow:0em 0em 0em 0em black, 0em 0em 0em 0em black inset}:host>div>.menu-frame-container.draggable{transition:all 350ms ease-in-out, top 1ms, left 1ms;padding:12px;border-radius:8px;cursor:move}:host>div>.menu-frame-container.draggable.fit-top{border-top-left-radius:0;border-top-right-radius:0}:host>div>.container.draggable.fit-right{border-top-right-radius:0;border-bottom-right-radius:0}:host>div>.menu-frame-container.draggable.fit-bottom{border-bottom-left-radius:0;border-bottom-right-radius:0}:host>div>.menu-frame-container.draggable.fit-left{border-top-left-radius:0;border-bottom-left-radius:0}:host>.popup{width:100%;height:100%}:host>.popup>.menu-frame-container{position:absolute;z-index:3;box-shadow:0px 3px 8px -3px black, 0em 0em 0em 0em black inset !important}:host>.popup>.menu-frame-container.draggable{user-select:none}:host>.popup>.menu-frame-container.closed{max-width:0;max-height:0;overflow:hidden}:host>.popup>.framer{min-width:100%;min-height:100%;padding:0 !important}:host>.sidebar{display:flex;flex-direction:row;width:100%;height:100%}:host>.sidebar>.menu-frame-container{box-shadow:0.16em 0.16em 0.54em -0.16em black, 0em 0em 0em 0em black inset !important}:host>.sidebar>.menu-frame-container.closed{max-width:12px;overflow:hidden;box-shadow:0em 0em 0em 0em black, -0.5em 0em 1.5em -0.5em black inset !important}:host>.sidebar,:host>.sidebar>.menu-frame-container.closed:hover{max-width:100%;overflow:auto}:host>.toolbar{display:flex;flex-direction:column;width:100%;height:100%}:host>.toolbar>.menu-frame-container{box-shadow:0px 0.16em 0.54em -0.16em black, 0em 0em 0em 0em black inset !important}:host>.toolbar>.menu-frame-container.closed{max-height:6px;overflow:hidden;box-shadow:0em 0em 0em 0em black, 0px -0.16em 0.54em -0.16em black inset !important}:host>.toolbar,:host>.toolbar>.menu-frame-container.closed:hover{max-height:100%;overflow:auto}:host>.sidebar.right{flex-direction:row-reverse}:host>.sidebar.right>.menu-frame-container{box-shadow:-0.16em 0.16em 0.54em -0.16em black, 0em 0em 0em 0em black inset !important}:host>.sidebar.right>.menu-frame-container.closed{box-shadow:0em 0em 0em 0em black, 0.5em 0em 1.5em -0.5em black inset !important}:host>.footer{display:flex;flex-direction:column-reverse;width:100%;height:100%}:host>.footer>.menu-frame-container{box-shadow:0px -0.16em 0.54em -0.16em black, 0em 0em 0em 0em black inset !important;min-height:min-content}:host>.footer>.framer{min-height:min-content}:host>.footer>.menu-frame-container.closed{max-height:0;overflow:hidden;box-shadow:0em 0em 0em 0em black, -0.5em 0em 1.5em -0.5em black inset !important}:host>.fab{width:100%;height:100%}:host>.fab>.menu-frame-container{position:absolute;top:initial !important;bottom:6px;z-index:3;background-color:transparent;box-shadow:0px 0.16em 8px -0.16em black, 0em 0em 0em 0em black inset !important}:host>.fab>.framer{min-width:100%;min-height:100%}:host>.fab>.menu-frame-container.closed{max-width:0;max-height:0;overflow:hidden}:host>.fullscreen{width:100%;height:100%}:host>.fullscreen>.menu-frame-container{position:absolute;z-index:3;width:100%;height:100%;box-shadow:0px 0.16em 0.54em -0.16em black, 0em 0em 0em 0em black inset !important;white-space:nowrap;text-align:center}:host>.fullscreen>.menu-frame-container:before{content:\"\";display:inline-block;vertical-align:middle;width:0;margin-right:-.25em;height:100%}:host>.fullscreen>.menu-frame-container>.content{position:relative;display:inline-block;vertical-align:middle;white-space:normal}:host>.fullscreen>.menu-frame-container.closed{max-height:0;overflow:hidden}:host>.fullscreen>.framer{min-width:100%;min-height:100%}\n  "]
                },] },
    ];
    AppMenuFrameComponent.ctorParameters = function () { return [
        { type: ElementRef, },
    ]; };
    return AppMenuFrameComponent;
}());

var TreeGridComponent = (function () {
    function TreeGridComponent() {
        this.gridType = 'grid';
        this.gridCols = 3;
        this.treeGridCols = 3;
        this.closed = true;
        this.needsDT = false;
        this.needsDD = false;
    }
    TreeGridComponent.prototype.ngAfterContentInit = function () {
        var _this = this;
        this.update();
        if (!!this.treeGrid.update) {
            this.treeGrid.update.subscribe(function () { return _this.update(); });
        }
    };
    TreeGridComponent.prototype.update = function () {
        if (!this.treeGrid.header) {
            this.treeGrid.header = this.header;
        }
        if (!this.treeGrid.contentTpls && !!this.contentTpls) {
            this.contentTpls._results.shift();
            this.treeGrid.contentTpls = this.contentTpls;
        }
        _a = this.treeGrid.build(this.id), this.head = _a[0], this.nodes = _a[1], this.elements = _a[2];
        if (this.head.length > 0 && !Type.isNull(this.head[0])) {
            if (this.head.length > 0) {
                this.needsDT = true;
                if (!this.head[0].hasOwnProperty('closed') || this.head[0].closed) {
                    this.closed = false;
                }
                this.toggleState();
            }
        }
        if (this.nodes.length > 0 || this.elements.length > 0) {
            this.needsDD = true;
        }
        var _a;
    };
    TreeGridComponent.prototype.toggleState = function () {
        this.closed = !this.closed;
        if (this.needsDT) {
            this.head[0].closed = this.closed;
        }
    };
    TreeGridComponent.decorators = [
        { type: Component, args: [{
                    selector: 'tree-grid',
                    inputs: [
                        'treeGrid: tree-grid',
                        'gridType: grid-type',
                        'gridCols: grid-columns',
                        'treeGridCols: tree-grid-columns',
                        'id: node-id'
                    ],
                    template: "\n    <div *ngIf=\"needsDT && needsDD\" class=\"grid-item\" (click)=\"toggleState()\">\n        <ng-template ngFor [ngForOf]=\"head\" [ngForTemplate]=\"treeGrid.header\"></ng-template>\n    </div>\n    <div *ngIf=\"needsDD\" class=\"grid-tree-item\"\n        [class.grid-tree-child]=\"needsDT\"\n        [class.closed]=\"closed\"\n        [style.columnCount]=\"treeGridCols\">\n\n        <tree-grid *ngFor=\"let nodeId of nodes\"\n            [tree-grid]=\"treeGrid\"\n            [node-id]=\"nodeId\"\n            [grid-type]=\"gridType\"\n            [grid-columns]=\"gridCols\"\n        ></tree-grid>\n        <grid\n            [grid-items]=\"elements\"\n            [grid-templates]=\"treeGrid.contentTpls\"\n            [grid-type]=\"gridType\"\n            [grid-columns]=\"gridCols\"\n        ></grid>\n    </div>\n  ",
                    styles: ["\n    ::-webkit-scrollbar{width:5px;height:4px}::-webkit-scrollbar-button{width:0px;height:0px}::-webkit-scrollbar-thumb{background:rgba(255,223,119,0.2)}::-webkit-scrollbar-track{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb:active{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb,::-webkit-scrollbar-track{border:none}::-webkit-scrollbar-track:hover,::-webkit-scrollbar-track:active,::-webkit-scrollbar-corner{background:transparent}o-dynamic-form-builder .dynamicform-container{height:100%}o-dynamic-form-builder .dynamicform-container .dropzone-container{height:95%;overflow:auto}:host .grid-item{display:inline-block;flex:1 1 auto;width:100%}:host .grid-tree-child{columns:5 24em;break-inside:avoid}:host.column,:host.column .grid-tree-item{display:flex;flex-direction:column}:host.row,:host.row .grid-tree-item{display:flex;flex-direction:row}:host.row .grid-item,:host.row .grid-tree-item .grid-item{width:initial}.grid-tree-child{transition:350ms;transition-timing-function:ease-in-out;background:rgba(0,0,0,0.1);overflow:auto;box-shadow:0.08em 0.16em 0.54em -0.16em black inset}.grid-tree-child.closed{max-height:0;overflow:hidden;box-shadow:0.3em 0.5em 1em -0.5em black inset}\n  "]
                },] },
    ];
    TreeGridComponent.propDecorators = {
        "header": [{ type: ContentChild, args: [TemplateRef,] },],
        "contentTpls": [{ type: ContentChildren, args: [TemplateRef,] },],
        "gridType": [{ type: HostBinding, args: ['class',] },],
    };
    return TreeGridComponent;
}());

var GridComponent = (function () {
    function GridComponent() {
        this.gridItems = new Array();
        this.gridType = 'grid';
        this.gridCols = 3;
        this.templates = new Array();
    }
    GridComponent.prototype.ngAfterContentInit = function () {
        if (!!this.contentTpls) {
            this.templates = this.templates.concat(this.contentTpls._results);
        }
        if (!!this.iContentTpls) {
            this.templates = this.templates.concat(this.iContentTpls._results);
        }
    };
    GridComponent.decorators = [
        { type: Component, args: [{
                    selector: 'grid',
                    inputs: [
                        'gridItems: grid-items',
                        'gridType: grid-type',
                        'gridCols: grid-columns',
                        'iContentTpls: grid-templates'
                    ],
                    template: "\n    <ng-template ngFor let-contentTpl [ngForOf]=\"templates\">\n        <div class=\"grid-item\" *ngFor=\"let item of gridItems\">\n            <ng-template ngFor [ngForOf]=\"[item]\" [ngForTemplate]=\"contentTpl\"></ng-template>\n        </div>\n    </ng-template>\n  ",
                    styles: ["\n    :host{display:block;columns:3 24em}:host .grid-item{display:inline-block;flex:1 1 auto;width:100%}:host.column{display:flex;flex-direction:column}:host.column-reverse{display:flex;flex-direction:column-reverse}:host.row{display:flex;flex-direction:row}:host.row .grid-item{width:initial}\n  "]
                },] },
    ];
    GridComponent.propDecorators = {
        "contentTpls": [{ type: ContentChildren, args: [TemplateRef,] },],
        "gridType": [{ type: HostBinding, args: ['class',] },],
        "gridCols": [{ type: HostBinding, args: ['style.columnCount',] },],
    };
    return GridComponent;
}());

var ComponentSettingsDialogComponent = (function () {
    function ComponentSettingsDialogComponent(dialogRef) {
        this.dialogRef = dialogRef;
        this.templateInputsData = {};
    }
    ComponentSettingsDialogComponent.prototype.ngOnInit = function () {
        this.formGroup = new FormGroup({});
        var self = this;
        this.formGroup.valueChanges
            .subscribe(function (value) {
            if (self.formDataCache === undefined) {
                self.formDataCache = {};
            }
            Object.assign(self.formDataCache, value);
        });
    };
    ComponentSettingsDialogComponent.prototype.ngOnDestroy = function () {
        this.formDataCache = undefined;
    };
    ComponentSettingsDialogComponent.prototype.registerFormControlComponent = function (comp) {
        if (comp) {
            var control = comp.getFormControl();
            if (control) {
                this.formGroup.addControl(comp.getPropertyName(), control);
            }
        }
    };
    ComponentSettingsDialogComponent.prototype.unregisterFormControlComponent = function (comp) {
        if (comp) {
            var control = comp.getFormControl();
            if (control) {
                this.formGroup.removeControl(comp.getPropertyName());
            }
        }
    };
    ComponentSettingsDialogComponent.prototype.setComponent = function (component) {
        this.component = component;
    };
    ComponentSettingsDialogComponent.prototype.setTemplateInputsData = function (inputsData) {
        var clonedInputsData = JSON.parse(JSON.stringify(inputsData));
        this.templateInputsData = clonedInputsData;
    };
    ComponentSettingsDialogComponent.prototype.save = function () {
        var _this = this;
        Object.keys(this.formGroup.controls).forEach(function (control) { return _this.formGroup.controls[control].markAsTouched(); });
        if (!this.formGroup.valid) {
            console.error('ERROR_MESSAGES.FORM_VALIDATION_ERROR');
            return;
        }
        var self = this;
        var configuredInputs = {};
        if (this.formDataCache) {
            var keys = Object.keys(this.formDataCache);
            keys.map(function (item) {
                var propertyValue = _this.formDataCache[item];
                if (self.templateInputsData[item].default !== propertyValue) {
                    configuredInputs[item] = propertyValue;
                    if (propertyValue !== undefined && typeof propertyValue !== 'string') {
                        configuredInputs[item] = propertyValue.toString();
                    }
                    if (self.templateInputsData[item].type === 'json') {
                        configuredInputs[item] = JSON.parse(propertyValue);
                    }
                }
            });
        }
        this.component.setConfiguredInputs(configuredInputs);
        this.dialogRef.close(this.component);
    };
    ComponentSettingsDialogComponent.prototype.cancel = function () {
        this.dialogRef.close(false);
    };
    ComponentSettingsDialogComponent.prototype.getInputData = function (inputName) {
        var inputData = this.templateInputsData[inputName];
        var configuredValue = this.component.getConfiguredInputValue(inputName);
        if (inputData.type === 'json') {
            configuredValue = JSON.stringify(configuredValue);
        }
        if (configuredValue !== undefined) {
            inputData.default = configuredValue;
        }
        return inputData;
    };
    ComponentSettingsDialogComponent.prototype.comparePropertyType = function (prop, type) {
        var propertyType = this.templateInputsData.hasOwnProperty(prop) ? this.templateInputsData[prop].type : undefined;
        if (type === 'text') {
            return (propertyType === 'string' || propertyType === 'number' || propertyType === 'json');
        }
        return (propertyType === type);
    };
    ComponentSettingsDialogComponent.decorators = [
        { type: Component, args: [{
                    selector: 'component-settings-dialog',
                    inputs: [],
                    template: "\n    <h1 mat-dialog-title> {{ component.getDirective() }} </h1>\n    <mat-dialog-content>\n      <form #settingsForm [formGroup]=\"formGroup\" fxLayout=\"column\">\n        <mat-grid-list cols=\"2\" rowHeight=\"5:1\" gutterSize=\"16\">\n          <mat-grid-tile *ngFor=\"let prop of component.getInputs()\" fxLayoutAlign=\"start center\">\n            <boolean-metadata fxFlexFill [property]=\"prop\" [data]=\"getInputData(prop)\" *ngIf=\"comparePropertyType(prop, 'boolean')\"></boolean-metadata>\n            <text-metadata fxFlexFill [property]=\"prop\" [data]=\"getInputData(prop)\" *ngIf=\"comparePropertyType(prop, 'text')\"></text-metadata>\n            <combo-metadata fxFlexFill [property]=\"prop\" [data]=\"getInputData(prop)\" *ngIf=\"comparePropertyType(prop, 'combo')\"></combo-metadata>\n          </mat-grid-tile>\n        </mat-grid-list>\n      </form>\n    </mat-dialog-content>\n\n    <mat-dialog-actions>\n      <button mat-raised-button (click)=\"save()\">{{ 'SAVE' | oTranslate }}</button>\n      <button mat-raised-button (click)=\"cancel()\">{{ 'CANCEL' | oTranslate }}</button>\n    </mat-dialog-actions>\n  ",
                    styles: ["\n    mat-dialog-content{max-height:75vh}\n  "]
                },] },
    ];
    ComponentSettingsDialogComponent.ctorParameters = function () { return [
        { type: MatDialogRef, },
    ]; };
    return ComponentSettingsDialogComponent;
}());

var DEFAULT_INPUTS_METADATA = [
    'property',
    'data'
];
var PropertyMetadataClass = (function () {
    function PropertyMetadataClass(settingsDialog) {
        this.settingsDialog = settingsDialog;
    }
    PropertyMetadataClass.prototype.initialize = function () {
        if (this.settingsDialog) {
            this.registerFormListeners();
        }
    };
    PropertyMetadataClass.prototype.registerFormListeners = function () {
        if (this.settingsDialog) {
            this.settingsDialog.registerFormControlComponent(this);
        }
    };
    PropertyMetadataClass.prototype.destroy = function () {
        this.unregisterFormListeners();
    };
    PropertyMetadataClass.prototype.unregisterFormListeners = function () {
        if (this.settingsDialog) {
            this.settingsDialog.unregisterFormControlComponent(this);
        }
    };
    PropertyMetadataClass.prototype.getFormGroup = function () {
        return this.settingsDialog.formGroup;
    };
    PropertyMetadataClass.prototype.getPropertyName = function () {
        if (this.property) {
            return this.property;
        }
        return undefined;
    };
    PropertyMetadataClass.prototype.getValue = function () {
        if (this.value) {
            return this.value.value;
        }
        return this.parseValue(this.data.default);
    };
    PropertyMetadataClass.prototype.parseValue = function (arg) {
        return arg;
    };
    PropertyMetadataClass.prototype.getFormControl = function () {
        if (!this.fControl) {
            var validators = this.resolveValidators();
            var cfg = {
                value: (this.data && this.data.default) ? this.data.default : undefined
            };
            this.fControl = new FormControl(cfg, validators);
        }
        return this.fControl;
    };
    PropertyMetadataClass.prototype.resolveValidators = function () {
        var validators = [];
        if (this.data.required) {
            validators.push(Validators.required);
        }
        return validators;
    };
    Object.defineProperty(PropertyMetadataClass.prototype, "isValid", {
        get: function () {
            if (this.fControl) {
                return this.fControl.valid;
            }
            return false;
        },
        enumerable: true,
        configurable: true
    });
    PropertyMetadataClass.prototype.innerOnChange = function (value) {
        this.value = { value: value };
    };
    PropertyMetadataClass.DEFAULT_INPUTS_METADATA = DEFAULT_INPUTS_METADATA;
    PropertyMetadataClass.ctorParameters = function () { return [
        { type: ComponentSettingsDialogComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ComponentSettingsDialogComponent; }),] },] },
    ]; };
    return PropertyMetadataClass;
}());

var __extends$22 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var DEFAULT_INPUTS_TEXT_METADATA = PropertyMetadataClass.DEFAULT_INPUTS_METADATA.slice();
var DEFAULT_OUTPUTS_TEXT_METADATA = [
    'onChange'
];
var TextMetadataComponent = (function (_super) {
    __extends$22(TextMetadataComponent, _super);
    function TextMetadataComponent(settingsDialog) {
        var _this = _super.call(this, settingsDialog) || this;
        _this.onChange = new EventEmitter();
        return _this;
    }
    TextMetadataComponent.prototype.parseValue = function (arg) {
        if (arg !== undefined && arg !== null && this.data.type === 'number' && typeof arg !== 'number') {
            return parseInt(arg);
        }
        return arg;
    };
    TextMetadataComponent.prototype.ngOnInit = function () {
        this.initialize();
    };
    TextMetadataComponent.prototype.ngOnDestroy = function () {
        this.destroy();
    };
    TextMetadataComponent.DEFAULT_INPUTS_TEXT_METADATA = DEFAULT_INPUTS_TEXT_METADATA;
    TextMetadataComponent.DEFAULT_OUTPUTS_TEXT_METADATA = DEFAULT_OUTPUTS_TEXT_METADATA;
    TextMetadataComponent.decorators = [
        { type: Component, args: [{
                    selector: 'text-metadata',
                    template: "\n    <div fxLayout=\"row\" layout-padding [formGroup]=\"getFormGroup()\">\n      <mat-form-field fxFlex>\n        <input matInput [attr.type]=\"data.type === 'number' ? 'number' : 'text'\" [attr.step]=\"data.type === 'number' ? 1 : undefined\"\n          [attr.min]=\"data.type === 'number' ? -1000 : undefined\" [attr.max]=\"data.type === 'number' ? 1000 : undefined\" [placeholder]=\"data.label\"\n          [ngModel]=\"getValue()\" (ngModelChange)=\"innerOnChange($event)\" [formControlName]=\"getPropertyName()\">\n        <mat-hint *ngIf=\"fControl.touched && fControl.errors\">\n          <span *ngIf=\"fControl.errors?.required\">FORM_VALIDATION.REQUIRED</span>\n          <span *ngIf=\"fControl.errors?.minlength\">FORM_VALIDATION.MIN_LENGTH: {{ fControl.errors?.minlength.requiredLength }}</span>\n          <span *ngIf=\"fControl.errors?.maxlength\">FORM_VALIDATION.MAX_LENGTH: {{ fControl.errors?.maxlength.requiredLength }}</span>\n        </mat-hint>\n      </mat-form-field>\n      <mat-icon fxFlex=\"10\" *ngIf=\"data.tooltip\" [matTooltip]=\"data.tooltip\" matTooltipPosition=\"right\" class=\"material-icons\">\n        info </mat-icon>\n    </div>\n  ",
                    styles: ["\n    mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-hint,mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-placeholder.mat-focused{color:#f44336}mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-underline{border-top-color:#f44336}mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-underline .mat-input-ripple{background-color:#f44336}mat-select{margin:16px 0}\n  "],
                    inputs: DEFAULT_INPUTS_TEXT_METADATA.slice(),
                    outputs: DEFAULT_OUTPUTS_TEXT_METADATA.slice(),
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    TextMetadataComponent.ctorParameters = function () { return [
        { type: ComponentSettingsDialogComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ComponentSettingsDialogComponent; }),] },] },
    ]; };
    return TextMetadataComponent;
}(PropertyMetadataClass));

var __extends$23 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var DEFAULT_INPUTS_BOOLEAN_METADATA = PropertyMetadataClass.DEFAULT_INPUTS_METADATA.slice();
var BooleanMetadataComponent = (function (_super) {
    __extends$23(BooleanMetadataComponent, _super);
    function BooleanMetadataComponent(settingsDialog) {
        var _this = _super.call(this, settingsDialog) || this;
        _this.onChange = new EventEmitter();
        return _this;
    }
    BooleanMetadataComponent.prototype.parseValue = function (arg) {
        if (arg !== undefined && arg !== null && typeof arg !== 'boolean') {
            return (arg === 'true');
        }
        return arg;
    };
    BooleanMetadataComponent.prototype.ngOnInit = function () {
        this.initialize();
    };
    BooleanMetadataComponent.prototype.ngOnDestroy = function () {
        this.destroy();
    };
    BooleanMetadataComponent.DEFAULT_INPUTS_BOOLEAN_METADATA = DEFAULT_INPUTS_BOOLEAN_METADATA;
    BooleanMetadataComponent.decorators = [
        { type: Component, args: [{
                    selector: 'boolean-metadata',
                    template: "\n    <div fxLayout=\"row\" fxLayoutAlign=\"space-between center\" fxFlexFill layout-padding [formGroup]=\"getFormGroup()\">\n      <mat-slide-toggle fxFlex fxLayoutAlign=\"start center\" [ngModel]=\"getValue()\" (ngModelChange)=\"innerOnChange($event)\" [formControlName]=\"getPropertyName()\">\n        {{ data.label }}\n      </mat-slide-toggle>\n      <mat-icon fxFlex=\"10\" fxFlexFill *ngIf=\"data.tooltip\" [matTooltip]=\"data.tooltip\" matTooltipPosition=\"right\" class=\"material-icons\">\n        info </mat-icon>\n    </div>\n  ",
                    styles: ["\n    mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-hint,mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-placeholder.mat-focused{color:#f44336}mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-underline{border-top-color:#f44336}mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-underline .mat-input-ripple{background-color:#f44336}mat-select{margin:16px 0}\n  "],
                    inputs: DEFAULT_INPUTS_BOOLEAN_METADATA.slice(),
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    BooleanMetadataComponent.ctorParameters = function () { return [
        { type: ComponentSettingsDialogComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ComponentSettingsDialogComponent; }),] },] },
    ]; };
    return BooleanMetadataComponent;
}(PropertyMetadataClass));

var __extends$24 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var DEFAULT_INPUTS_COMBO_METADATA = PropertyMetadataClass.DEFAULT_INPUTS_METADATA.slice();
var ComboMetadataComponent = (function (_super) {
    __extends$24(ComboMetadataComponent, _super);
    function ComboMetadataComponent(settingsDialog) {
        var _this = _super.call(this, settingsDialog) || this;
        _this.onChange = new EventEmitter();
        return _this;
    }
    ComboMetadataComponent.prototype.ngOnInit = function () {
        this.initialize();
    };
    ComboMetadataComponent.prototype.ngOnDestroy = function () {
        this.destroy();
    };
    ComboMetadataComponent.DEFAULT_INPUTS_COMBO_METADATA = DEFAULT_INPUTS_COMBO_METADATA;
    ComboMetadataComponent.decorators = [
        { type: Component, args: [{
                    selector: 'combo-metadata',
                    template: "\n    <div fxLayout=\"row\" fxLayoutAlign=\"space-between center\" fxFlexFill layout-padding [formGroup]=\"getFormGroup()\">\n      <mat-select fxFlex [placeholder]=\"data.label\" [ngModel]=\"getValue()\" (ngModelChange)=\"innerOnChange($event)\" [formControlName]=\"getPropertyName()\">\n        <mat-option *ngIf=\"!data.required\">\n        </mat-option>\n        <mat-option *ngFor=\"let value of data.values\" [value]=\"value\">\n          {{ value }}\n        </mat-option>\n      </mat-select>\n      <mat-icon fxFlex=\"10\" fxFlexFill *ngIf=\"data.tooltip\" [matTooltip]=\"data.tooltip\" matTooltipPosition=\"right\" class=\"material-icons\">\n        info </mat-icon>\n    </div>\n  ",
                    styles: ["\n    mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-hint,mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-placeholder.mat-focused{color:#f44336}mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-underline{border-top-color:#f44336}mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-underline .mat-input-ripple{background-color:#f44336}mat-select{margin:16px 0}\n  "],
                    inputs: DEFAULT_INPUTS_COMBO_METADATA.slice(),
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    ComboMetadataComponent.ctorParameters = function () { return [
        { type: ComponentSettingsDialogComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ComponentSettingsDialogComponent; }),] },] },
    ]; };
    return ComboMetadataComponent;
}(PropertyMetadataClass));

function getAppMenuServiceProvider() {
    return new AppMenuService();
}
function getComponentsDataServiceProvider() {
    return new ComponentsDataService();
}
var O_DYNAMICFORM_BUILDER_PROVIDERS = [
    {
        provide: AppMenuService,
        useFactory: getAppMenuServiceProvider
    },
    {
        provide: ComponentsDataService,
        useFactory: getComponentsDataServiceProvider
    }
];

var __decorate = (undefined && undefined.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (undefined && undefined.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var ODynamicFormBuilderComponent = (function () {
    function ODynamicFormBuilderComponent(dialog, componentsDataService, parentForm) {
        this.dialog = dialog;
        this.componentsDataService = componentsDataService;
        this.parentForm = parentForm;
        this.autoBinding = true;
        this.autoRegistering = true;
        this.innerFormDefinition = null;
        this.componentsArray = new ArrayList();
        this.render = new EventEmitter();
        this.onFormDefinitionUpdate = new EventEmitter();
    }
    ODynamicFormBuilderComponent.prototype.ngOnInit = function () {
        var setDefaultDef = !this.formDefinition;
        if (setDefaultDef) {
            this.innerFormDefinition = {
                'components': []
            };
        }
        if (this.parentForm) {
            this.registerFormListeners();
            this._isReadOnly = this.parentForm.isInInitialMode();
        }
        else {
            this._isReadOnly = false;
        }
    };
    ODynamicFormBuilderComponent.prototype.registerFormListeners = function () {
        if (this.parentForm) {
            this.parentForm.registerFormComponent(this);
            this.parentForm.registerSQLTypeFormComponent(this);
        }
    };
    ODynamicFormBuilderComponent.prototype.ngOnDestroy = function () {
        this.unregisterFormListeners();
    };
    ODynamicFormBuilderComponent.prototype.unregisterFormListeners = function () {
        if (this.parentForm) {
            this.parentForm.unregisterFormComponent(this);
            this.parentForm.unregisterSQLTypeFormComponent(this);
        }
    };
    ODynamicFormBuilderComponent.prototype.setValue = function (val) {
        this.formDefinition = val;
    };
    ODynamicFormBuilderComponent.prototype.getAttribute = function () {
        if (this.oattr) {
            return this.oattr;
        }
        return undefined;
    };
    ODynamicFormBuilderComponent.prototype.getSQLType = function () {
        return SQLTypes.OTHER;
    };
    ODynamicFormBuilderComponent.prototype.reloadInnerFormMode = function () {
        this.innerForm.setFormMode(this.innerForm.mode);
    };
    ODynamicFormBuilderComponent.prototype.onDynamicFormRendered = function () {
        this.reloadInnerFormMode();
        if (this.render) {
            this.render.emit(true);
        }
    };
    Object.defineProperty(ODynamicFormBuilderComponent.prototype, "data", {
        set: function (value) {
            var formDef = undefined;
            if (value instanceof OFormValue) {
                formDef = value.value;
            }
            if (!formDef) {
                formDef = {
                    'components': []
                };
            }
            this.formDefinition = formDef;
        },
        enumerable: true,
        configurable: true
    });
    ODynamicFormBuilderComponent.prototype.isAutomaticBinding = function () {
        return this.autoBinding;
    };
    ODynamicFormBuilderComponent.prototype.isAutomaticRegistering = function () {
        return this.autoRegistering;
    };
    ODynamicFormBuilderComponent.prototype.getComponentsFromJSON = function (componentsJSON, parent) {
        for (var i = 0; i < componentsJSON.length; i++) {
            var comp = Object.assign({}, componentsJSON[i]);
            if (comp.hasOwnProperty('ontimize-directive')) {
                var compData = this.componentsDataService.getOntimizeComponentData(comp['ontimize-directive']);
                delete comp['ontimize-directive'];
                compData.setConfiguredInputs(comp);
                if (compData.isContainer() && comp.hasOwnProperty('children') && comp.children.length) {
                    this.getComponentsFromJSON(comp.children, compData.children);
                }
                parent.push(compData);
            }
        }
    };
    Object.defineProperty(ODynamicFormBuilderComponent.prototype, "formDefinition", {
        get: function () {
            return this.innerFormDefinition;
        },
        set: function (definition) {
            var definitionJSON = definition;
            if (typeof definition === 'string') {
                try {
                    definitionJSON = JSON.parse(definition);
                }
                catch (e) {
                    console.error('set formDefinition error');
                }
            }
            this.componentsArray = new ArrayList();
            if (definitionJSON && definitionJSON.hasOwnProperty('components') && definitionJSON.components.length) {
                this.getComponentsFromJSON(definitionJSON.components, this.componentsArray);
            }
            this.innerFormDefinition = definitionJSON;
        },
        enumerable: true,
        configurable: true
    });
    ODynamicFormBuilderComponent.prototype.definitionToString = function () {
        return JSON.stringify(this.formDefinition);
    };
    ODynamicFormBuilderComponent.prototype.onUpdateComponents = function () {
        var componentsParsedArray = [];
        this.getComponentsJson(this.componentsArray, componentsParsedArray);
        this.formDefinition = { components: componentsParsedArray };
        this.onFormDefinitionUpdate.emit(this.innerFormDefinition);
    };
    ODynamicFormBuilderComponent.prototype.getComponentsJson = function (components, parent) {
        for (var i = 0; i < components.length; i++) {
            var comp = components[i];
            var compInputs = comp.getConfiguredInputs();
            var compObj = Object.assign({}, compInputs);
            compObj['ontimize-directive'] = comp.getDirective();
            if (comp.isContainer()) {
                compObj['children'] = [];
                this.getComponentsJson(comp.getChildren(), compObj['children']);
            }
            parent.push(compObj);
        }
    };
    ODynamicFormBuilderComponent.prototype.openSettingsDialog = function (component, args) {
        var self = this;
        var dialogRef = this.dialog.open(ComponentSettingsDialogComponent, {
            width: '60%',
            disableClose: true
        });
        dialogRef.componentInstance.setTemplateInputsData(component.getTemplateInputsData());
        dialogRef.componentInstance.setComponent(component);
        dialogRef.afterClosed().subscribe(function (newComponent) {
            if (newComponent !== false && newComponent instanceof OComponentData) {
                var emptyArgs = !Object.keys(args || {}).length;
                if (emptyArgs) {
                    self.componentsArray.unshift(newComponent);
                }
                else if (args.hasOwnProperty('previousSibling')) {
                    self._insertElement(args.previousSibling.getComponentAttr(), self.componentsArray, newComponent);
                }
                else if (args.hasOwnProperty('parent')) {
                    args.parent.addChild(newComponent);
                }
                self.onUpdateComponents();
            }
        });
    };
    ODynamicFormBuilderComponent.prototype.getComponentsArray = function () {
        return this.componentsArray.toArray();
    };
    ODynamicFormBuilderComponent.prototype.onAddComponent = function (args) {
        var component = args.component;
        var previousSibling = this.getOComponentData(args.previousSibling);
        var parent = this.getOComponentData(args.parent);
        var dialogArgs = {};
        if (previousSibling) {
            dialogArgs['previousSibling'] = previousSibling;
        }
        if (parent) {
            dialogArgs['parent'] = parent;
        }
        this.openSettingsDialog(component, dialogArgs);
    };
    ODynamicFormBuilderComponent.prototype.onMoveComponent = function (args) {
        var component = args.component;
        this.onDeleteComponent(args);
        var newComponent = this.cloneComponent(component);
        if (args.hasOwnProperty('previousSibling')) {
            this._insertElement(args.previousSibling.getComponentAttr(), this.componentsArray, newComponent);
        }
        else if (args.hasOwnProperty('parent')) {
            var parent_1 = this._searchElement(args.parent.getComponentAttr(), this.componentsArray);
            if (parent_1) {
                parent_1.addChild(newComponent);
            }
        }
        else {
            this.componentsArray.unshift(newComponent);
        }
        this.onUpdateComponents();
    };
    ODynamicFormBuilderComponent.prototype.onEditComponentSettings = function (args) {
        var component = this.getOComponentData(args.component);
        if (!component) {
            return;
        }
        this.openSettingsDialog(component, { edit: true });
    };
    ODynamicFormBuilderComponent.prototype.onDeleteComponent = function (args) {
        var component = this.getOComponentData(args.component);
        if (!component) {
            return;
        }
        this._removeElement(component.getComponentAttr(), this.componentsArray);
        this.onUpdateComponents();
    };
    ODynamicFormBuilderComponent.prototype.getOComponentData = function (fieldComponent) {
        if (!fieldComponent) {
            return undefined;
        }
        var component = this._searchElement(fieldComponent.getComponentAttr(), this.componentsArray);
        return component;
    };
    ODynamicFormBuilderComponent.prototype.cloneComponent = function (component) {
        return this._cloneComponentData(component.settings);
    };
    Object.defineProperty(ODynamicFormBuilderComponent.prototype, "isReadOnly", {
        get: function () {
            return this._isReadOnly;
        },
        set: function (value) {
            this._isReadOnly = value;
        },
        enumerable: true,
        configurable: true
    });
    ODynamicFormBuilderComponent.prototype.getControl = function () {
        return undefined;
    };
    ODynamicFormBuilderComponent.prototype.getFormControl = function () {
        return undefined;
    };
    ODynamicFormBuilderComponent.prototype.hasError = function (error) {
        return false;
    };
    ODynamicFormBuilderComponent.prototype._searchElement = function (id, array) {
        var r;
        for (var i = 0; i < array.length; i++) {
            if (id === array[i].getComponentAttr()) {
                return array[i];
            }
            if (array[i].children && array[i].children.length > 0) {
                if ((r = this._searchElement(id, array[i].children)) !== null) {
                    return r;
                }
            }
        }
        return null;
    };
    ODynamicFormBuilderComponent.prototype._insertElement = function (id, array, newComponent) {
        for (var i = 0; i < array.length; i++) {
            if (id === array[i].getComponentAttr()) {
                array.splice(i + 1, 0, newComponent);
            }
            if (array[i].children) {
                this._insertElement(id, array[i].children, newComponent);
            }
        }
    };
    ODynamicFormBuilderComponent.prototype._removeElement = function (id, array) {
        for (var i = 0; i < array.length; i++) {
            if (id === array[i].getComponentAttr()) {
                array.splice(i, 1);
            }
            if (array[i] && array[i].children) {
                this._removeElement(id, array[i].children);
            }
        }
    };
    ODynamicFormBuilderComponent.prototype._cloneComponentData = function (settings) {
        var _this = this;
        var newComponent = this.componentsDataService.getOntimizeComponentData(settings['ontimize-directive']);
        delete settings['ontimize-directive'];
        newComponent.setConfiguredInputs(settings);
        if (settings.children) {
            settings.children.forEach(function (child) {
                newComponent.addChild(_this._cloneComponentData(child));
            });
        }
        return newComponent;
    };
    ODynamicFormBuilderComponent.decorators = [
        { type: Component, args: [{
                    selector: 'o-dynamic-form-builder',
                    template: "\n    <app-menu id=\"FORM_BUILDER_MANAGER\" class=\"framed\" ui-element=\"sidebar\" fxFlex\n      [drag-enabled]=\"!isReadOnly\">\n      <div fxLayout=\"row\" fxLayoutAlign=\"center center\" class=\"dynamicform-container\" fxFlexFill>\n          <div fxLayout=\"row\" fxLayoutAlign=\"center\" fxFlex=\"90\" class=\"mat-elevation-z1 dropzone-container\">\n            <extended-form #innerForm show-header=\"false\" fxFlex=\"100\" query-on-init=\"false\">\n\n              <div fxLayout=\"column\">\n                <o-dynamic-form\n                  #dynamicForm\n                  query-on-init=\"false\"\n                  register-in-parent-form=\"false\"\n                  [form-definition]=\"formDefinition\"\n                  [edit-mode]=\"!isReadOnly\"\n                  (onAddComponent)=\"onAddComponent($event)\"\n                  (onMoveComponent)=\"onMoveComponent($event)\"\n                  (onEditComponentSettings)=\"onEditComponentSettings($event)\"\n                  (onDeleteComponent)=\"onDeleteComponent($event)\"\n                  (render)=\"onDynamicFormRendered()\">\n                </o-dynamic-form>\n              </div>\n            </extended-form>\n          </div>\n      </div>\n    </app-menu>\n  ",
                    styles: ["\n    ::-webkit-scrollbar{width:5px;height:4px}::-webkit-scrollbar-button{width:0px;height:0px}::-webkit-scrollbar-thumb{background:rgba(255,223,119,0.2)}::-webkit-scrollbar-track{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb:active{background:rgba(17,17,17,0.3)}::-webkit-scrollbar-thumb,::-webkit-scrollbar-track{border:none}::-webkit-scrollbar-track:hover,::-webkit-scrollbar-track:active,::-webkit-scrollbar-corner{background:transparent}o-dynamic-form-builder .dynamicform-container{height:100%}o-dynamic-form-builder .dynamicform-container .dropzone-container{height:95%;overflow:auto}\n  "],
                    inputs: [
                        'oattr :attr',
                        'autoBinding: automatic-binding',
                        'autoRegistering: automatic-registering',
                        'formDefinition: form-definition'
                    ],
                    outputs: [
                        'render',
                        'onFormDefinitionUpdate'
                    ],
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    ODynamicFormBuilderComponent.ctorParameters = function () { return [
        { type: MatDialog, },
        { type: ComponentsDataService, },
        { type: OFormComponent, decorators: [{ type: Optional }, { type: Inject, args: [forwardRef(function () { return OFormComponent; }),] },] },
    ]; };
    ODynamicFormBuilderComponent.propDecorators = {
        "innerForm": [{ type: ViewChild, args: ['innerForm',] },],
        "dynamicForm": [{ type: ViewChild, args: ['dynamicForm',] },],
    };
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODynamicFormBuilderComponent.prototype, "autoBinding", void 0);
    __decorate([
        InputConverter(),
        __metadata("design:type", Boolean)
    ], ODynamicFormBuilderComponent.prototype, "autoRegistering", void 0);
    return ODynamicFormBuilderComponent;
}());

var __extends$25 = (undefined && undefined.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var ɵ0 = dataServiceFactory;
var ExtendedFormComponent = (function (_super) {
    __extends$25(ExtendedFormComponent, _super);
    function ExtendedFormComponent(router, actRoute, zone, cd, injector, elRef) {
        return _super.call(this, router, actRoute, zone, cd, injector, elRef) || this;
    }
    ExtendedFormComponent.prototype.isInitialStateChanged = function () {
        return false;
    };
    ExtendedFormComponent.decorators = [
        { type: Component, args: [{
                    selector: 'extended-form',
                    providers: [
                        { provide: OntimizeService, useFactory: ɵ0, deps: [Injector] },
                        {
                            provide: OFormComponent,
                            useExisting: forwardRef(function () { return ExtendedFormComponent; })
                        }
                    ],
                    template: "\n    <ng-host oKeyboardListener keyboardKeys=\"17;90\" (onKeysPressed)=\"undoKeyboardPressed()\">\n      <div fxFlex=\"grow\">\n        <o-form-toolbar *ngIf=\"showHeader\" [label-header]=\"labelheader\" [label-header-align]=\"labelHeaderAlign\" [header-actions]=\"headeractions\"\n          [show-header-navigation]=\"showHeaderNavigation\" [show-header-actions-text]=\"showHeaderActionsText\" [class.o-form-toolbar-floating]=\"headerMode === 'floating'\"\n          [class.o-form-toolbar-floating-scrolled]=\"hasScrolled\">\n\n          <div o-custom-form-toolbar-buttons-wrapper fxLayout=\"row\" fxLayoutAlign=\"end center\">\n            <ng-content select=\"[o-form-toolbar-buttons]\"></ng-content>\n          </div>\n        </o-form-toolbar>\n\n        <form #innerForm [formGroup]=\"formGroup\" class=\"inner-form\" [class.form-no-toolbar]=\"!showHeader\"\n          fxLayout=\"column\" autocomplete=\"off\" autocorrect=\"off\" autocapitalize=\"off\" spellcheck=\"false\">\n          <div fxFlex=\"100\" *ngIf=\"loading\" class=\"progress-bar-container\">\n            <mat-progress-bar mode=\"indeterminate\"></mat-progress-bar>\n          </div>\n          <div layout-padding [class.force-display-block]=\"layoutDirection === 'column'\" [fxLayout]=\"layoutDirection\" class=\"o-form-content-wrapper\">\n            <ng-content></ng-content>\n          </div>\n        </form>\n      </div>\n    </ng-host>\n  ",
                    inputs: OFormComponent.DEFAULT_INPUTS_O_FORM,
                    outputs: OFormComponent.DEFAULT_OUTPUTS_O_FORM,
                    encapsulation: ViewEncapsulation.None,
                    host: {
                        '[class.o-form]': 'true',
                        '[class.fill]': 'layoutFill'
                    }
                },] },
    ];
    ExtendedFormComponent.ctorParameters = function () { return [
        { type: Router, },
        { type: ActivatedRoute, },
        { type: NgZone, },
        { type: ChangeDetectorRef, },
        { type: Injector, },
        { type: ElementRef, },
    ]; };
    return ExtendedFormComponent;
}(OFormComponent));

var O_DYNAMICFORM_BUILDER_COMPONENTS = [
    AppMenuFrameComponent,
    AppMenuComponent,
    AppMenuTitleComponent,
    AppMenuItemComponent,
    TreeGridComponent,
    GridComponent,
    TextMetadataComponent,
    BooleanMetadataComponent,
    ComboMetadataComponent,
    ComponentSettingsDialogComponent,
    ODynamicFormBuilderComponent,
    ExtendedFormComponent
];

var DynamicFormBuilderModule = (function () {
    function DynamicFormBuilderModule() {
    }
    DynamicFormBuilderModule.decorators = [
        { type: NgModule, args: [{
                    imports: [
                        OntimizeWebModule,
                        CommonModule,
                        DndModule.forRoot(),
                        DynamicFormModule
                    ],
                    declarations: O_DYNAMICFORM_BUILDER_COMPONENTS,
                    exports: O_DYNAMICFORM_BUILDER_COMPONENTS,
                    entryComponents: [
                        ComponentSettingsDialogComponent
                    ],
                    providers: O_DYNAMICFORM_BUILDER_PROVIDERS,
                    schemas: [CUSTOM_ELEMENTS_SCHEMA]
                },] },
    ];
    return DynamicFormBuilderModule;
}());

export { DynamicFormBuilderModule, O_DYNAMICFORM_BUILDER_COMPONENTS, ComponentSettingsDialogComponent, ODynamicFormBuilderComponent, AppMenuComponent, AppMenuTitleComponent, AppMenuItemComponent, AppMenuFrameComponent, TreeGridComponent, GridComponent, TreeListDefault, TextMetadataComponent, BooleanMetadataComponent, ComboMetadataComponent, getAppMenuServiceProvider, getComponentsDataServiceProvider, O_DYNAMICFORM_BUILDER_PROVIDERS, AppMenuService, ComponentsDataService };
//# sourceMappingURL=ontimize-web-ngx-dynamicform-builder.js.map
