var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { Component, Inject, forwardRef, EventEmitter, ViewEncapsulation } from '@angular/core';
import { PropertyMetadataClass } from './property.metadata.class';
import { ComponentSettingsDialogComponent } from '../component-settings-dialog.component';
export var DEFAULT_INPUTS_COMBO_METADATA = PropertyMetadataClass.DEFAULT_INPUTS_METADATA.slice();
var ComboMetadataComponent = (function (_super) {
    __extends(ComboMetadataComponent, _super);
    function ComboMetadataComponent(settingsDialog) {
        var _this = _super.call(this, settingsDialog) || this;
        _this.onChange = new EventEmitter();
        return _this;
    }
    ComboMetadataComponent.prototype.ngOnInit = function () {
        this.initialize();
    };
    ComboMetadataComponent.prototype.ngOnDestroy = function () {
        this.destroy();
    };
    ComboMetadataComponent.DEFAULT_INPUTS_COMBO_METADATA = DEFAULT_INPUTS_COMBO_METADATA;
    ComboMetadataComponent.decorators = [
        { type: Component, args: [{
                    selector: 'combo-metadata',
                    template: "\n    <div fxLayout=\"row\" fxLayoutAlign=\"space-between center\" fxFlexFill layout-padding [formGroup]=\"getFormGroup()\">\n      <mat-select fxFlex [placeholder]=\"data.label\" [ngModel]=\"getValue()\" (ngModelChange)=\"innerOnChange($event)\" [formControlName]=\"getPropertyName()\">\n        <mat-option *ngIf=\"!data.required\">\n        </mat-option>\n        <mat-option *ngFor=\"let value of data.values\" [value]=\"value\">\n          {{ value }}\n        </mat-option>\n      </mat-select>\n      <mat-icon fxFlex=\"10\" fxFlexFill *ngIf=\"data.tooltip\" [matTooltip]=\"data.tooltip\" matTooltipPosition=\"right\" class=\"material-icons\">\n        info </mat-icon>\n    </div>\n  ",
                    styles: ["\n    mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-hint,mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-placeholder.mat-focused{color:#f44336}mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-underline{border-top-color:#f44336}mat-form-field.ng-invalid.ng-touched .mat-input-wrapper .mat-input-underline .mat-input-ripple{background-color:#f44336}mat-select{margin:16px 0}\n  "],
                    inputs: DEFAULT_INPUTS_COMBO_METADATA.slice(),
                    encapsulation: ViewEncapsulation.None
                },] },
    ];
    ComboMetadataComponent.ctorParameters = function () { return [
        { type: ComponentSettingsDialogComponent, decorators: [{ type: Inject, args: [forwardRef(function () { return ComponentSettingsDialogComponent; }),] },] },
    ]; };
    return ComboMetadataComponent;
}(PropertyMetadataClass));
export { ComboMetadataComponent };
//# sourceMappingURL=combo-metadata.component.js.map