import { OnInit, EventEmitter } from '@angular/core';
import { MatDialog } from '@angular/material';
import { FormControl } from '@angular/forms';
import { OFormComponent, IComponent, IFormDataTypeComponent, IFormDataComponent } from 'ontimize-web-ngx';
import { ODynamicFormComponent } from 'ontimize-web-ngx-dynamicform';
import { ArrayList } from './utils';
import { ComponentsDataService } from './services';
import { OComponentData } from './ontimize-components-data';
export declare class ODynamicFormBuilderComponent implements OnInit, IComponent, IFormDataTypeComponent, IFormDataComponent {
    protected dialog: MatDialog;
    protected componentsDataService: ComponentsDataService;
    protected parentForm: OFormComponent;
    protected oattr: string;
    autoBinding: boolean;
    autoRegistering: boolean;
    protected _isReadOnly: boolean;
    innerForm: OFormComponent;
    dynamicForm: ODynamicFormComponent;
    innerFormDefinition: any;
    componentsArray: ArrayList<OComponentData>;
    render: EventEmitter<any>;
    onFormDefinitionUpdate: EventEmitter<Object>;
    constructor(dialog: MatDialog, componentsDataService: ComponentsDataService, parentForm: OFormComponent);
    ngOnInit(): void;
    registerFormListeners(): void;
    ngOnDestroy(): void;
    unregisterFormListeners(): void;
    setValue(val: any): void;
    getAttribute(): string;
    getSQLType(): number;
    reloadInnerFormMode(): void;
    onDynamicFormRendered(): void;
    data: any;
    isAutomaticBinding(): boolean;
    isAutomaticRegistering(): boolean;
    getComponentsFromJSON(componentsJSON: any, parent: any): void;
    formDefinition: any;
    definitionToString(): string;
    onUpdateComponents(): void;
    getComponentsJson(components: ArrayList<OComponentData>, parent: Array<any>): void;
    openSettingsDialog(component: OComponentData, args?: any): void;
    getComponentsArray(): OComponentData[];
    onAddComponent(args: any): void;
    onMoveComponent(args: any): void;
    onEditComponentSettings(args: any): void;
    onDeleteComponent(args: any): void;
    getOComponentData(fieldComponent: any): any;
    cloneComponent(component: any): OComponentData;
    isReadOnly: boolean;
    getControl(): FormControl;
    getFormControl(): FormControl;
    hasError(error: string): boolean;
    private _searchElement(id, array);
    private _insertElement(id, array, newComponent);
    private _removeElement(id, array);
    private _cloneComponentData(settings);
}
